//=============================================================================
// Description: TBreakString qrꤤXlrꪺ
//-----------------------------------------------------------------------------
// Author: PC-Prince
//-----------------------------------------------------------------------------
// Version: 1.0
//-----------------------------------------------------------------------------
// Date: 1997/06/24
//-----------------------------------------------------------------------------
// Property:
//   SourceString: _rӷr
//   Fixed: = True, Tw榡r
//          = False, H Spearator @jIr
//   Separator:
//     if Fixed=True, Separator is like '8/10/4', 䤤 8,10,4 Orƥ
//     else Separator = @jIlr
//   FillZero: = True, Nreťզr0
//   Trim: = True, Neťզrh
//   Count: Ϋұorƥ
//   Items[]: Ϋ᪺lr}C
//-----------------------------------------------------------------------------
// Method:
//   Run: _r\
//-----------------------------------------------------------------------------
// Event: None
//-----------------------------------------------------------------------------
// Notes: p (Fixed=False) and Separator@Ӧr, N|Ҽ{rp
//=============================================================================
unit BreakStr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  EFormatedTextException = class(Exception);

  TBreakString = class(TComponent)
  private
    { Private declarations }
    FFixed: Boolean;          // =True,TwΦ; =False,HjrϤ
    FTrim: Boolean;           // Ϋ᪺rO_hťզr
    FFillZero: Boolean;       // ťզrO_meɦr '0',
                              //     ȥΩ FTrim = False
    FSeparator: string;       // if FFixed=True, O榡ƪr, p '10/5/8/4',
                              // else jr
    FSourceString: string;    // Τӷr
    FList: TStringList;       // s񵲪Gr}C
    FCount: Integer;          // Φr᪺Ӽ
  protected
    { Protected declarations }
    procedure CutFixedStr;
    procedure CutNoneFixedStr;
    function GetItem(Index: Integer): string;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Run;
    property Items[Index: Integer]: string read GetItem; default;
  published
    { Published declarations }
    property Fixed: Boolean read FFixed write FFixed;
    property Trim: Boolean read FTrim write FTrim;
    property FillZero: Boolean read FFillZero write FFillZero;
    property Separator: string read FSeparator write FSeparator;
    property SourceString: string read FSourceString write FSourceString;
    property Count: Integer read FCount;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TBreakString]);
end;

constructor TBreakString.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FList := TStringList.Create;
end;

destructor TBreakString.Destroy;
begin
  FList.Free;
  inherited Destroy;
end;

procedure TBreakString.Run;
begin
  if FSourceString = '' then exit;
  if not (csDesigning in ComponentState) then
  begin
    FList.Clear;
    FCount := 0;
    if FSeparator = '' then
      raise EFormatedTextException.Create('TBreakString Error: Xk榡r(1)!');
    // Starting to separate the FSourceString
    if FFixed then CutFixedStr
    else CutNoneFixedStr;
  end;
end;

//=============================================================================
// Description: NrөTwm
//-----------------------------------------------------------------------------
// Parameters:
//-----------------------------------------------------------------------------
// Return Value: None
//-----------------------------------------------------------------------------
// Author: PC-Prince
//-----------------------------------------------------------------------------
// Date: 1997/06/23 (1st Version)
//=============================================================================
procedure TBreakString.CutFixedStr;
var
  i, value, j, k: Integer;
  tmp, target: string;
begin
  tmp := FSeparator + '/';
  FCount := 0;
  k := 1;
  try
    i := Pos('/',tmp);
    while i <> 0 do
    begin
      value := StrToInt(Copy(tmp,1,i-1));
      tmp := Copy(tmp,i+1,Length(tmp)-i);
      target := Copy(FSourceString,k,value);
      if FTrim then FList.Add(TrimLeft(TrimRight(target)))
      else if not FFillZero then FList.Add(target)
      else // fill '0' char
      begin
        for j:=1 to Length(target) do
        begin
          if target[j] <> ' ' then break
          else target[j] := '0';
        end;
        FList.Add(target);
      end;
      Inc(k,value);
      Inc(FCount);
      i := Pos('/',tmp);
    end;
  except
    raise EFormatedTextException.Create('TBreakString Error: Xk榡r(2)!');
  end;
end;

function TBreakString.GetItem(Index: Integer): string;
begin
  if (Index < 0) or (Index >= FList.Count) then
    raise EFormatedTextException.Create('TBreakString Error: ޶WXd!');
  Result := FList[Index];
end;

procedure TBreakString.CutNoneFixedStr;
var
  i, len, k: Integer;
  tmp, target: string;

  procedure Addstr;
  var
    j: Integer;
  begin
    if FTrim then FList.Add(TrimLeft(TrimRight(target)))
    else if not FFillZero then FList.Add(target)
    else // fill '0' char
    begin
      for j:=1 to Length(target) do
      begin
        if target[j] <> ' ' then break
        else target[j] := '0';
      end;
      FList.Add(target);
    end;
    Inc(FCount);
  end;

begin
  tmp := FSourceString + FSeparator;
  if Length(FSeparator) <= 0 then exit
  else if Length(FSeparator) = 1 then
  begin   // [W襤rBz
    k := 1;
    len := Length(tmp);
    i := 1;
    while i <= len do
    begin
      if Windows.IsDBCSLeadByte(Byte(tmp[i])) then
      begin
        // rX{
        Inc(i,2);
        Continue;
      end;
      if tmp[i] = FSeparator[1] then
      begin
        target := Copy(tmp,k,i-k);
        k := i + 1;
        AddStr;
      end;
      Inc(i);
    end;
  end
  else  // Length(FSeparator) > 1, Bz, ӳ·ФF :)
  begin
    len := Length(FSeparator);
    i := Pos(FSeparator,tmp);
    while i <> 0 do
    begin
      target := Copy(tmp,1,i-1);
      tmp := Copy(tmp,i+len,Length(tmp)-i-len+1);
      AddStr;
      i := Pos(FSeparator,tmp);
    end;
  end;
end;

end.
